"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

/**
 * @typedef {Object} LoggerConfig
 * @property {string} [level=process.env.WEBEX_LOG_LEVEL] - Maximum log level that
 * should be printed to the console. One of
 * silent|error|warn|log|info|debug|trace
 * @property {number} [historyLength=1000] - Maximum number of entries to store in the log buffer.
 * @example
 * {
 *   level: process.env.WEBEX_LOG_LEVEL,
 *   historyLength: 1000
 * }
 */

exports.default = {
  logger: {
    level: process.env.WEBEX_LOG_LEVEL,
    historyLength: 1000
  }
};
//# sourceMappingURL=config.js.map
