'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EventsUtil = {};

EventsUtil.getEventLog = function (args) {
  var argString = '';

  try {
    argString = (0, _stringify2.default)(args);
  } catch (e) {
    // no op
  }

  return argString;
};

EventsUtil.getScopeLog = function (scope) {
  var scopeString = '';

  if (scope) {
    if (scope.file && scope.function) {
      scopeString += scope.file + ':' + scope.function + '->';

      return scopeString;
    }
    if (scope.file) {
      scopeString += scope.file + '->';
    }
    if (scope.function) {
      scopeString += scope.function + '->';
    }
  }

  return scopeString;
};

exports.default = EventsUtil;
//# sourceMappingURL=util.js.map
