const EventsUtil = {};

EventsUtil.getEventLog = (args) => {
  let argString = '';

  try {
    argString = JSON.stringify(args);
  }
  catch (e) {
    // no op
  }

  return argString;
};

EventsUtil.getScopeLog = (scope) => {
  let scopeString = '';

  if (scope) {
    if (scope.file && scope.function) {
      scopeString += `${scope.file}:${scope.function}->`;

      return scopeString;
    }
    if (scope.file) {
      scopeString += `${scope.file}->`;
    }
    if (scope.function) {
      scopeString += `${scope.function}->`;
    }
  }

  return scopeString;
};

export default EventsUtil;
