'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _has2 = require('lodash/has');

var _has3 = _interopRequireDefault(_has2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _httpCore = require('@webex/http-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @class
 */
/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

var RequestLoggerInterceptor = function (_Interceptor) {
  (0, _inherits3.default)(RequestLoggerInterceptor, _Interceptor);

  function RequestLoggerInterceptor() {
    (0, _classCallCheck3.default)(this, RequestLoggerInterceptor);
    return (0, _possibleConstructorReturn3.default)(this, (RequestLoggerInterceptor.__proto__ || (0, _getPrototypeOf2.default)(RequestLoggerInterceptor)).apply(this, arguments));
  }

  (0, _createClass3.default)(RequestLoggerInterceptor, [{
    key: 'onRequest',


    /**
     * @see Interceptor#onRequest
     * @param {Object} options
     * @returns {Object}
     */
    value: function onRequest(options) {
      var logger = (0, _get3.default)(this, 'webex.logger', console);

      logger.info('/**********************************************************************\\ ');
      logger.info('Request:', options.method || 'GET', options.uri);
      logger.info('WEBEX_TRACKINGID: ', (0, _get3.default)(options, 'headers.trackingid'));
      /* istanbul ignore next */
      if ((0, _has3.default)(options, 'headers.x-trans-id')) {
        logger.info('X-Trans-ID: ', (0, _get3.default)(options, 'headers.x-trans-id'));
      }
      var now = new Date();

      if (process.env.ENABLE_VERBOSE_NETWORK_LOGGING) {
        logger.info('timestamp (start): ', now.getTime(), now.toISOString());
        try {
          // Determine if body is a buffer without relying on Buffer to avoid
          // node/browser conflicts.
          if (options.body && options.body.length && !(0, _isArray3.default)(options.body) && !(0, _isString3.default)(options.body)) {
            logger.info('Request Options:', _util2.default.inspect((0, _omit3.default)(options, 'body'), { depth: null }));
          } else {
            logger.info('Request Options:', _util2.default.inspect(options, { depth: null }));
          }
        } catch (e) {
          logger.warn('Could not stringify request options:', e);
        }
      }

      return _promise2.default.resolve(options);
    }

    /**
     * @see Interceptor#onRequest
     * @param {Object} options
     * @param {Error} reason
     * @returns {Object}
     */

  }, {
    key: 'onRequestError',
    value: function onRequestError(options, reason) {
      // We need to do the normal onRequest logging, but then log how the request
      // failed since the response logger won't be called.
      this.onRequest(options);
      var logger = (0, _get3.default)(this, 'webex.logger', console);

      logger.error('Request Failed: ', reason.stack);
      logger.info('\\**********************************************************************/');

      return _promise2.default.reject(reason);
    }
  }], [{
    key: 'create',

    /**
     * @returns {RequestLoggerInterceptor}
     */
    value: function create() {
      return new RequestLoggerInterceptor({ webex: this });
    }
  }]);
  return RequestLoggerInterceptor;
}(_httpCore.Interceptor);

exports.default = RequestLoggerInterceptor;
//# sourceMappingURL=request-logger.js.map
