---
permalink: /docs/adapters/
---

# Adapters

Adapters are the interface to the service you want your hubot to run on.

Hubot includes two official adapters:

* [Shell](./adapters/shell.md), i.e. for use with development
* [Campfire](./adapters/campfire.md)

There are Third-party adapters available for most chat services. Here are the most popular ones:

* [Gitter](https://github.com/huafu/hubot-gitter2)
* [HipChat](https://github.com/hipchat/hubot-hipchat)
* [IRC](https://github.com/nandub/hubot-irc)
* [Rocket.Chat](https://github.com/RocketChat/hubot-rocketchat)
* [Slack](https://github.com/slackhq/hubot-slack)
* [XMPP](https://github.com/markstory/hubot-xmpp)

Browse all [repositories with the `hubot-adapter` topic on GitHub](https://github.com/search?q=topic%3Ahubot-adapter&type=Repositories) or [search for adapters on NPM](https://www.npmjs.com/search?q=hubot%20adapter&ranking=popularity). Add the `hubot-adapter` [topic](https://help.github.com/articles/classifying-your-repository-with-topics/) to your repository on GitHub to include it in this list.

## Writing Your Own Adapter

Interested in adding your own adapter? Check out our documentation for [developing adapters](./adapters/development.md)
